%
% lakat.P
% by pts@fazekas.hu at Sat Jan 11 16:36:33 CET 2003
% Mon Jan 27 14:03:49 CET 2003
% abstract evaluation azt mondja, hogy no :-( at Mon Jan 27 17:54:12 CET 2003
% mkdik! at Mon Jan 27 20:43:28 CET 2003
%
% A dokumentcit lsd lakat.txt-ben.
%

:- import member/2 from basics.
:- import append/3 from basics.

% SICStus-ban gy, van, valsznleg XSB-ben is (XSB manual-ban nem talltam)
%     :- op( 1200, xfx, [ :-, --> ]).
%     :- op( 1200,  fx, [ :-, ?- ]).
%     :- op( 1150,  fx, [ mode, public, dynamic, volatile, discontiguous,
%                         multifile, block, meta_predicate,
%                         initialization ]).
%     :- op( 1100, xfy, [ ; ]).
%     :- op( 1050, xfy, [ -> ]).
%     :- op( 1000, xfy, [ ',' ]).
%     :- op(  900,  fy, [ \+, spy, nospy ]).
%     :- op(  700, xfx, [ =, \=, is, =.., ==, \==, @<, @>, @=<, @>=,
%                                     =:=, =\=, <, >, =<, >= ]).
%     :- op(  550, xfy, [ : ]).
%     :- op(  500, yfx, [ +, -, #, /\, \/ ]).
%     :- op(  400, yfx, [ *, /, //, mod, rem, <<, >> ]).
%     :- op(  200, xfx, [ ** ]).
%     :- op(  200, xfy, [ ^ ]).
%     :- op(  200,  fy, [ +, -, \ ]).
%  The following operators differ in sicstus execution mode. 
%     :- op(  500,  fx, [ +, - ]).
%     :- op(  300, xfx, [ mod ]).
%
% XSB-ben megllaptottam: current_op(X, Y, Z), print(op(X,Y,Z)), nl, fail.
%   op(1200,xfx,[:-,-->])
%   op(1200,fx,[:-,?-])
%   op(1198,xfx,::-)
%   op(1150,fx,[hilog,dynamic,multifile])
%   op(1100,xfy,;)
%   op(1100,fx,[table,use_variant_tabling,use_subsumptive_tabling,edb,mode,export,parallel,local,foreign_pred,compile_command,attribute])
%   op(1100,fy,[index,ti,ti_off])
%   op(1050,fy,import)
%   op(1050,xfx,from)
%   op(1050,xfy,->)
%   op(1000,xfy,',')
%   op(900,fy,[not,\+,spy,nospy])
%   op(700,xfx,[=,\=,==,\==,@<,@=<,@>,@>=,=..,^=..,is,=:=,=\=,<,=<,>,>=])
%   op(661,xfy,.)
%   op(600,xfy,:)
%   op(500,yfx,[+,-,/\,\/])
%   op(400,yfx,[*,/,//,mod,rem,MM,>>,\,^])

% Dat: stop-nak nincs paramtere, ezrt  nem opertor
% vvv 1000-nl alacsonyabbnak kell lennie, klnben print(throw 42) nem megy.
:- op(952, fx, if).
:- op(951, xfx, then).
:- op(950, fx, [throw,input,write,print,let,goto]).
:- op(400, yfx, div).
:- op(700, xfx, [<=,<>]).

% --- segdfggvnyek

write_string([]).
write_string([C|Cs]) :- put_code(C), write_string(Cs).

% --- parse-ols (szintaktikai elemzs), eval vgrehajts nlkl

% Az albbi eljrsok pontosan akkor sikeresek, ha a paramterl megadott
% kifejezsfa az eljrs nevnek megfelel tpus. Kt fajta ellenrzs van:
% felletes (azt ellenrzi, hogy ,,nem lehet ms tpus: csak ilyen lehet,
% vagy parse error ''), s a mly (azt ellenrzi, hogy ,,mindenkppen ilyen
% tpus'').

% string konstans?
l0c_string(X) :- var(X), !, fail.
l0c_string([]).
l0c_string([C|Cs]) :-
  integer(C), 0 =< C, C =< 255, l0c_string(Cs).

% undef konstans?
l0c_undef(undef).

% int konstans?
l0c_int(X) :- integer(X).

% string kifejezs? mly
l0x_string(X) :- l0c_string(X).

% string kifejezs? felletes
l0s_string(X) :- l0c_string(X).

% int ktvltozs opertor? (nonvar(X)-et felttelezve)
l0c_op(+). l0c_op(-). l0c_op(*). l0c_op(div). l0c_op(mod). l0c_op(==).
l0c_op(<>). l0c_op(<). l0c_op(<=).

% int kifejezs? mly
l0x_int(X) :- var(X), !, fail.
l0x_int(-X) :- !, l0x_int(X).
l0x_int(X) :-
  ( atom(X)
  ; integer(X)
  ; (X =.. [Op, Y, Z], l0c_op(Op), l0x_int(Y), l0x_int(Z))
  ).

% int kifejezs? felletes
l0s_int(X) :- var(X), !, fail.
l0s_int(-_X) :- !.
l0s_int(X) :-
  ( atom(X)
  ; integer(X)
  ; (X =.. [Op, _Y, _Z], l0c_op(Op))
  ).

% kifejezs? mly
l0x_expr(X) :- nonvar(X), ( l0x_int(X) ; l0x_string(X) ; X = undef ).

% kifejezs? felletes
l0s_expr(X) :- nonvar(X), ( l0s_int(X) ; l0s_string(X) ; X = undef ).

% cmke?
l0c_label(X) :-
  ( var(X) -> fail
  ; atom(X)
  ; (X = Y/Z ; atom(Y), integer(Z), 0 =< Z)
  ).

% utasts cmke nlkl? mly
l0x_st0l(X) :- var(X), !, fail.
l0x_st0l(stop).
l0x_st0l(throw X) :- l0x_string(X).
l0x_st0l(input X) :- atom(X).
l0x_st0l(write X) :- l0x_expr(X).
l0x_st0l(print X) :- l0x_string(X).
l0x_st0l(let X = Y) :- atom(X), l0x_expr(Y).
l0x_st0l(if X then goto Y) :- l0x_expr(X), l0c_label(Y).
l0x_st0l(goto X) :- l0c_label(X).

% utasts cmke nlkl? felletes
l0s_st0l(X) :- var(X), !, fail.
l0s_st0l(stop).
l0s_st0l(throw X) :- l0s_string(X).
l0s_st0l(input X) :- atom(X).
l0s_st0l(write X) :- l0s_expr(X).
l0s_st0l(print X) :- l0s_string(X).
l0s_st0l(let X = Y) :- atom(X), l0s_expr(Y).
l0s_st0l(if X then goto Y) :- l0s_expr(X), l0c_label(Y).
l0s_st0l(goto X) :- l0c_label(X).

% utasts? mly
l0x_stetement(X) :- var(X), !, fail.
l0x_statement((X -> Y)) :- !, l0c_label(X), l0x_st0l(Y).
l0x_statement(X) :- l0x_st0l(X).

% utasts? felletes
l0s_stetement(X) :- var(X), !, fail.
l0s_statement((X -> _Y)) :- !, l0c_label(X).
l0s_statement(X) :- l0s_st0l(X).

% program? mly
l0x_program(X) :- var(X), !, fail.
l0x_program((X ; end_of_file)) :- !, l0x_statement(X).
l0x_program((X ; Y)) :- !, l0x_statement(X), l0x_program(Y).
l0x_program(X) :- l0x_statement(X).

% program? sekly
l0s_program(X) :- var(X), !, fail.
l0s_program((X ; end_of_file)) :- !, l0s_statement(X).
l0s_program((X ; Y)) :- !, l0s_statement(X), l0s_program(Y).
l0s_program(X) :- l0s_statement(X).

% --- egyszer Lakat -> LVG talakts
%
% -- a kifejezsfk felptse a zrjelek s a precedencik figyelembe
%    vtelvel
% -- ``cmke'' -> ``cmke/0'' konverzi
% -- ``goto'' -> ``if 1 then goto'' konverz
% -- ``print'' fordtsa ``WRITE''-ra
% -- elhagyott cmkk ptlsa
% -- zr ``STOP'' utasts beszrsa, stop/0 cmkvel

% l0trans_st0l(+X, -W): az X cmke nlkli utasts a W cmke nlkli
% utastsra fordul
l0trans_st0l(print X, W) :- !, append(X, [10], XL), W = (write XL).
l0trans_st0l(goto Y, W) :- !, l0trans_label(Y, Z), W = (if 1 then goto Z).
l0trans_st0l(if X then goto Y, W) :- !, l0trans_label(Y, Z), W = (if X then goto Z).
l0trans_st0l(X, X).

% l0trans_label(+X, -W): az X cmke a W cmkre fordul
l0trans_label(X/Y, X/Y) :- !.
l0trans_label(X, X/0).

% l0trans_statetement(+L, +Y, -W) :- Az Y utasts L default cmkvel
% a W utastsra fordul.
l0trans_statement(_L, (X -> Y), W) :- !,
  l0trans_label(X, M),
  l0trans_st0l(Y, Z),
  W = (M -> Z).
l0trans_statement(L, Y, W) :- l0trans_st0l(Y, Z), W = (L -> Z).

% l0trans_program(+X, -W): az X program a W programra fordul
l0trans_program(X, W) :-
  l0trans_program(start/0, X, W).

% l0trans_program(+L, +X, -W): az X program L kezd default cmkvel a W
% programra fordul.
l0trans_program(L, (X ; end_of_file), W) :- !,
  l0trans_statement(L, X, S),
  W = (S ; stop/0 -> stop ; stop/1 -> stop).
l0trans_program(L, (X ; Y), W) :- !,
  l0trans_statement(L, X, S),
  S = (A/B -> _), B1 is B+1,
  W = (S ; V), % cselesen lehetv tesszk a balrekurzit
  l0trans_program(A/B1, Y, V).
l0trans_program(L, X, W) :-
  l0trans_statement(L, X, S),
  W = (S ; stop/0 -> stop ; stop/1 -> stop).

% Regr.Test:
% ?- l0trans_program((print "x"; goto stop; z -> let c = d), Y).
% Y = (start / 0 -> write [120,10]  ';'  start / 1 -> if 1  then  goto stop / 0  ';'  z / 0 -> let c = d  ';'  stop / 0 -> stop);

% --- kdfk nyomtatsa

% l0print_statement(X): az X utastst kinyomtatja
% Imp: `(z / 0 -> let c = d)' zrjel nlkl
% Imp: string konstansok idzjel kztt, "" duplzssal
l0print_statement(X) :- print(X), nl.

% l0print_program(X): az X programkd-ft kinyomtatja
l0print_program((X ; end_of_file)) :- !, l0print_statement(X).
l0print_program((X ; Y)) :- !, l0print_statement(X), l0print_program(Y).
l0print_program(X) :- l0print_statement(X).

% --- a hasznlt vltozk listjnak kigyjtse (csak LVG)

% l0default(+Xs, ?Alap, ?Ws):
% l0default(-Xs, +Alap, +Ws):
% Az Ys lista ugy all elo, hogy az Xs lista minden
% eleme utn Alap-ot beszrjuk.
l0default([], _, []) :- !.
l0default([X,Alap|Xs], Alap, [X|Ys]) :- l0default(Xs, Alap, Ys).

% l0vars(+P, +Alap, -Vs) :- P programfa vltozinak listja Vs,
% Alap alaprtkkel (azaz Vs = [vltoz1, Alapertek, vltoz2, Alapertek
% ...]). Bemeneti felttel: l0x_program(P).
l0vars(X, Alap, Vs) :-
  l0vars_program(X, [], Us), 
  l0default(Vs, Alap, Us).

% l0vars_program(+P, Ts, -Vs) :- (P programfa vltozinak listja uni Ts)
% = Vs. Bemeneti felttel: l0x_program(P).
l0vars_program((_ -> Y ; Z), Ts, Vs) :- !, l0vars_st0l(Y, Ts, Us), l0vars_program(Z, Us, Vs).
l0vars_program((_ -> Y), Ts, Vs) :- l0vars_st0l(Y, Ts, Vs).

l0vars_st0l(stop, Ts, Vs) :- !, Vs = Ts.
l0vars_st0l(throw X, Ts, Vs) :- !, l0vars_expr(X, Ts, Vs).
l0vars_st0l(input X, Ts, Vs) :- !, l0vars_add(X, Ts, Vs).
l0vars_st0l(write X, Ts, Vs) :- !, l0vars_expr(X, Ts, Vs).
l0vars_st0l(let X = Y, Ts, Vs) :- !, l0vars_add(X, Ts, Us), l0vars_expr(Y, Us, Vs).
l0vars_st0l(if X then goto _Y, Ts, Vs) :- !, l0vars_expr(X, Ts, Vs).

% l0vars_add(+Vs, +V, -Xs) :- Xs vltozlista gy keletkezik, hogy a Vs
% listba felvesszk V-t is.
l0vars_add(V, Vs, Xs) :-
  ( member(V, Vs) -> Xs = Vs
  ; Xs = [V|Vs]
  ).

% l0vars_expr(+X, +Vs, -Xs) :- X kifejezs, Vs vltozlista, Xs a Vs-t s
% X vltozinak unijt tartalmazza.
l0vars_expr(-X, Vs, Xs) :- !, l0vars_expr(X, Vs, Xs).
l0vars_expr(undef, Vs, Xs) :- !, Xs = Vs.
l0vars_expr([], Vs, Xs) :- !, Xs = Vs.
l0vars_expr([_|_], Vs, Xs) :- !, Xs = Vs.
l0vars_expr(X, Vs, Xs) :-
  X =.. [_Op, Y, Z], !,
  l0vars_expr(Y, Vs, Ws),
  l0vars_expr(Z, Ws, Xs).
l0vars_expr(X, Vs, Xs) :-
  ( atom(X) -> l0vars_add(X, Vs, Xs)
  ; Xs = Vs
  ).

% --- LVG interpreter (nem absztrakt)

% l0i_let(+Bind, +R, +Val, -Cind): Cind vltozlista gy ll el, hogy a Bind
% listban az R vltoz rtkt Val-ra cserljk.
l0i_let([], _, _, _) :- !, fail.
l0i_let([R,_|Vs], R, Val, [R,Val|Vs]) :- !.
l0i_let([V,X|Vs], R, Val, [V,X|Ys]) :- l0i_let(Vs, R, Val, Ys).

% l0i_get(+Bind, +R, ?Val): a Bind vltozlistban az R vltoz rtke Val.
l0i_get([R,X|_ ], R, X) :- !.
l0i_get([_,_|Vs], R, X) :- l0i_get(Vs, R, X).

% l0i_eval(+Bind, +X, ?E) :- Az X kifejezs rtke a vltozk Bind rtke
% mellett E.
l0i_eval(_Bind,undef, E) :- !, E = undef.
l0i_eval(_Bind,[],    E) :- !, E = [].
l0i_eval(_Bind,X,     E) :- X=[_|_], !, E = X.
l0i_eval(Bind, X,     E) :- l0i_evalint(Bind, X, E).

% l0i_evalint(+bind, +X, ?E): Az X egsz-kifejezs rtke a vltozk Bind
% rtke mellett E.
l0i_evalint(_Bind,X, E) :- integer(X), !, E is X.
l0i_evalint(Bind, R, E) :- atom(R), !, l0i_get(Bind, R, E).
l0i_evalint(Bind, -X,      E) :- !, l0i_evalint(Bind, X, C), E is -C.
l0i_evalint(Bind, X +   Y, E) :- !, l0i_evalint(Bind, X, C), l0i_evalint(Bind, Y, D), E is C+D.
l0i_evalint(Bind, X -   Y, E) :- !, l0i_evalint(Bind, X, C), l0i_evalint(Bind, Y, D), E is C-D.
l0i_evalint(Bind, X *   Y, E) :- !, l0i_evalint(Bind, X, C), l0i_evalint(Bind, Y, D), E is C*D.
l0i_evalint(Bind, X div Y, E) :- !, l0i_evalint(Bind, X, C), l0i_evalint(Bind, Y, D), E is C // D.
l0i_evalint(Bind, X mod Y, E) :- !, l0i_evalint(Bind, X, C), l0i_evalint(Bind, Y, D), E is C mod D.
l0i_evalint(Bind, X ==  Y, E) :- !, l0i_evalint(Bind, X, C), l0i_evalint(Bind, Y, D), ( C =:= D -> E = 1 ; E = 0 ).
l0i_evalint(Bind, X <>  Y, E) :- !, l0i_evalint(Bind, X, C), l0i_evalint(Bind, Y, D), ( C =:= D -> E = 0 ; E = 1 ).
l0i_evalint(Bind, X <   Y, E) :- !, l0i_evalint(Bind, X, C), l0i_evalint(Bind, Y, D), ( C <   D -> E = 1 ; E = 0 ).
l0i_evalint(Bind, X <=  Y, E) :- !, l0i_evalint(Bind, X, C), l0i_evalint(Bind, Y, D), ( C =<  D -> E = 1 ; E = 0 ).

% Regr.teszt:
% | ?- l0i_eval([a,5,b,6], a+b, X).
% X = 11;
% | ?- l0i_eval([a,5,b,6], a-b, X).
% X = -1;
% | ?- l0i_eval([a,5,b,6], a/2+b, X).
% | ?- l0i_eval([a,5,b,6], a div 2+b, X).
% X = 8;
% | ?- l0i_eval([a,5,b,6], a div 2+c, X).

% l0i_st0l(Bind, Stam, M, Cind): a vltozk Bind rtke mellett vgrehajtott
% Stam utasts az M cmkre ugrik, s a vltozk rtkt Cind-re mdostja.
% Ha az utasts nem ugrik sehov, hanem halad tovbb, akkor M-et ``step''-pel
% egyestjk.
l0i_st0l(Bind, stop, M, Cind) :- !, M = stop/0, Cind = Bind.
l0i_st0l(Bind, throw X, M, Cind) :- !,
  l0i_eval(Bind, X, E),
  write('l0 abort: '), write_string(E), nl,
  M = stop/1, Cind = Bind.
l0i_st0l(Bind, input R, M, Cind) :- !,
  ( read(Val) ->
    ( l0c_int(Val) -> (l0i_let(Bind, R, Val, Cind), M = step)
    ; write('l0 error: user typed not int'), nl, M = stop/1, Cind = Bind
    )
  ; write('l0 error: error reading user'), nl, M = stop/1, Cind = Bind
  ).
l0i_st0l(Bind, write X, M, Cind) :- !,
  l0i_eval(Bind, X, E),
  % write_string(E),
  ( integer(E) -> write(E) ; write_string(E) ),
  Cind = Bind, M = step.
l0i_st0l(Bind, let R = X, M, Cind) :- !,
  l0i_eval(Bind, X, E),
  l0i_let(Bind, R, E, Cind), M = step.
l0i_st0l(Bind, if X then goto L, M, Cind) :- !,
  l0i_eval(Bind, X, E),
  Cind = Bind,
  ( E =:= 0 -> M = step
  ; M = L
  ).

% l0i_goto(+Prog, +L, -Now): a Prog programban az L cmkre ugorva a Now
% programrszhez jutunk (Now rszfja Prog-nake). L nem lehet stop/_ alak.
l0i_goto(Prog, L, Now) :-
  ( Prog = (L -> _ ; Y) -> Now = Prog
  % ; Prog = (L -> _) -> Now = Prog
  % ^^^ elhagyhat, mert a stop/1 s stop/2 utastsok sentinel-knt jelen vannak
  ; Prog = (_; Y) -> l0i_goto(Y, L, Now)
  % ; fail % flsleges
  ).

% l0i_program(+Bind, +Prog, +Now, -M, -Cind): a vltozk Bind rtke mellett Now
% LVG-fa elejtl elkezdve futtatni a Prog programot (Now rszfja Prog-nak),
% a program a vltozk rtkt Cind-re mdostja, s az M cmknl r vget.
% (M = stop/0 cmke ``stop'' utasts, M = stop/1 ``throw'' utasts hatsrsa
% keletkezik) Az l0i_program nem biztos, hogy vget r (pl. ha az LVG-fban
% specifiklt program vgtelen ciklusba keveredik.
%   Egyetlen klz elg, mert a vgn gyis van kt ``stop'' utasts.
l0i_program(Bind, Prog, (K -> Stam ; Y), M, Cind) :- !,
  l0i_st0l(Bind, Stam, L, Bond),
  ( L = stop/_ ->         (M = K, Cind = Bind)
  ; L = step ->           l0i_program(Bond, Prog, Y, M, Cind)
  ; l0i_goto(Prog, L, Z), l0i_program(Bond, Prog, Z, M, Cind)
  ).

% --- norml programkd fordtsa absztrakt kdd

% l0a_isimple(+E, ?F): F egsz-kifejezs ugyanazt szmolja ki, mint F, de
% nmileg egyszerbb (rvidebb).
l0a_isimple(X, E) :- integer(X), !, E is X.
l0a_isimple(X, E) :- atom(X), !, E is X.
l0a_isimple(-X,      E) :- !, l0a_isimple(X, C), (integer(C) -> E is -C ; E = -X ).
l0a_isimple(X +   Y, E) :- !, l0a_isimple(X, C), l0a_isimple(Y, D), (integer(C), integer(D) -> E is C+D; E = C+D).
l0a_isimple(X -   Y, E) :- !, l0a_isimple(X, C), l0a_isimple(Y, D), (integer(C), integer(D) -> E is C-D; E = C-D).
l0a_isimple(X *   Y, E) :- !, l0a_isimple(X, C), l0a_isimple(Y, D), (integer(C), integer(D) -> E is C*D; E = C*D).
l0a_isimple(X div Y, E) :- !, l0a_isimple(X, C), l0a_isimple(Y, D), (integer(C), integer(D) -> E is C // D; E = C div D).
l0a_isimple(X mod Y, E) :- !, l0a_isimple(X, C), l0a_isimple(Y, D), (integer(C), integer(D) -> E is C mod D; E = C mod D).
l0a_isimple(X ==  Y, E) :- !, l0a_isimple(X, C), l0a_isimple(Y, D), (integer(C), integer(D) -> ( C =:= D -> E = 1 ; E = 0 ) ; E = (C == D)).
l0a_isimple(X <>  Y, E) :- !, l0a_isimple(X, C), l0a_isimple(Y, D), (integer(C), integer(D) -> ( C =:= D -> E = 0 ; E = 1 ) ; E = (C <> D)).
l0a_isimple(X <   Y, E) :- !, l0a_isimple(X, C), l0a_isimple(Y, D), (integer(C), integer(D) -> ( C <   D -> E = 1 ; E = 0 ) ; E = (C <  D)).
l0a_isimple(X <=  Y, E) :- !, l0a_isimple(X, C), l0a_isimple(Y, D), (integer(C), integer(D) -> ( C =<  D -> E = 1 ; E = 0 ) ; E = (C <= D)).

% Regr.teszt:
% l0a_isimple(a+1+2, X).
% X = a + 1 + 2;
% | ?- l0a_isimple(1+2+a, X).
% X = 3 + a;

% l0a_abstractint1(+I, ?A): I egsz szm absztrakt rtke A
% (A in -2, -1, 0, 1, 2).
l0a_abstractint1(I, A) :-
  ( I = 0 -> A = 0
  ; M is I mod 2,
    ( I < 0, M = 0 -> A = -2
    ; I < 0 -> A = -1
    ; M = 1 -> A = 1
    ; A = 2
    )
  ).

% l0a_abstractint(+X, ?E) :- Az X egsz-kifejezs absztrakt alakja E.
l0a_abstractint(X, E) :- atom(X), !, E = X.
l0a_abstractint(X, E) :- integer(X), !, l0a_abstractint1(X, E).
l0a_abstractint(-X, E) :- !, l0a_abstractint(X, D), E = -D.
l0a_abstractint(X, E) :-
  X =.. [Op, Y, Z], l0c_op(Op),
  l0a_abstractint(Y, C), l0a_abstractint(Z, D),
  E =.. [Op, C, D].

% l0a_abstractint(+X, ?E) :- Az X kifejezs absztrakt alakja E.
l0a_abstract(undef, E) :- !, E = undef.
l0a_abstract([],    E) :- !, E  = string.
l0a_abstract(X,     E) :- X=[_|_], !, E = string.
l0a_abstract(X,     E) :- l0a_isimple(X, D), l0a_abstractint(D, E).

% l0a_abstractst0l(Stam, T) :- A Stam cmke nlkli utasts absztrakt alakja
% T.
l0a_abstractst0l(stop, T) :- !, T = stop.
l0a_abstractst0l(throw X, T) :- !, l0a_abstract(X, E), T = (throw E).
l0a_abstractst0l(input R, T) :- !, T = (input R).
l0a_abstractst0l(write X, T) :- !,
  l0a_abstract(X, E), % flsleges, mert gy se hajtjuk vgre
  T = (write E).
l0a_abstractst0l(let R = X, T) :- !, l0a_abstract(X, E), T = (let R = E). 
l0a_abstractst0l(if X then goto L, T) :- !, l0a_abstract(X, E), T = (if E then goto L).

% l0a_abstractprogram(Prog, U) :- A Prog LVG-program absztrakt alakja U.
l0a_abstractprogram(Prog, U) :-
  Prog = (L -> Stam ; Y),
  ( L = stop/_ -> U = Prog
  ; l0a_abstractst0l(Stam, T),
    U = (L -> T ; Z),
    l0a_abstractprogram(Y, Z)
  ).

% --- futtats absztrakt mdban

% Tbbek kztt kikszbli az ``l0a_evalint([], (-1 <= -2)*2+1, E)''
% hvs tbbszrs visszatrst.
:- table l0a_evalint/3.
:- table l0a_program/8.
% Nem :- table: l0a_eval, l0b_add, l0b_mul, l0b_div, l0b_mod, l0b_modm, l0b_lt,
%   l0b_le, l0a_st0l, l0a_goto, 

% l0a_eval(+Bind, +X, ?E) :- Az X absztrakt kifejezs absztrakt rtke a
% vltozk Bind rtke mellett E.
l0a_eval(_Bind,undef, E) :- !, E = undef.
l0a_eval(_Bind,string,E) :- !, E = string.
l0a_eval(Bind, X,     E) :- l0a_evalint(Bind, X, E).

% l0b_add(+X, +Y, -Z) :- X, Y s Z absztrakt egszek, X + Y = Z.
l0b_add(0, X, X) :- !.
l0b_add(X, 0, X) :- !.
l0b_add(-2, -2, -2).
l0b_add(-2, -1, -1).
l0b_add(-2, 1, -1).
l0b_add(-2, 1, 1).
l0b_add(-2, 2, -2). % multi
l0b_add(-2, 2, 0).
l0b_add(-2, 2, 2).
l0b_add(-1, -2, -1).
l0b_add(-1, -1, -2).
l0b_add(-1, 1, -2). % multi
l0b_add(-1, 1, 0).
l0b_add(-1, 1, 2).
l0b_add(-1, 2, -1). % multi
l0b_add(-1, 2, 1).
l0b_add(2, 2, 2).
l0b_add(2, 1, 1).
l0b_add(2, -1, -1).
l0b_add(2, -1, 1).
l0b_add(2, -2, -2). % multi
l0b_add(2, -2, 0).
l0b_add(2, -2, 2).
l0b_add(1, 2, 1).
l0b_add(1, 1, 2).
l0b_add(1, -1, -2). % multi
l0b_add(1, -1, 0).
l0b_add(1, -1, 2).
l0b_add(1, -2, -1). % multi
l0b_add(1, -2, 1).

% l0b_mul(+X, +Y, -Z) :- X, Y s Z absztrakt egszek, X * Y = Z.
l0b_mul(0, _, 0) :- !.
l0b_mul(_, 0, 0) :- !.
l0b_mul(1, X, X) :- !.
l0b_mul(X, 1, X) :- !.
l0b_mul(-1, X, Y) :- !, Y is -X.
l0b_mul(X, -1, Y) :- !, Y is -X.
l0b_mul(2, -2, -2).
l0b_mul(-2, 2, -2).
l0b_mul(2, 2, 2).
l0b_mul(-2, -2, 2).

% l0b_div(+X, +Y, -Z) :- X, Y s Z absztrakt egszek, X div Y = Z. Mivel
% maradkos osztsrl van sz, Z paritst nem lehet megllaptani.
l0b_div(_, 0, _) :- !, fail.
l0b_div(0, _, 0) :- !.
l0b_div(X, Y, Z) :-
  ( X < 0, Y < 0 -> (Z = 0; Z = 1; Z = 2) % multi
  ; 0 < X, 0 < Y -> (Z = 0; Z = 1; Z = 2) % multi
  ; (Z = 0; Z = -1; Z = -2) % multi
  ).

% l0b_mod(+X, +Y, -Z) :- X, Y s Z absztrakt egszek, X mod Y = Z. Z eljele
% megegyezik Y eljelvel (vagy 0).
l0b_mod(_, 0, _) :- !, fail.
l0b_mod(0, _, 0) :- !.
l0b_mod(2, Y, Z) :- !, l0b_modm(-2, Y, Z).
l0b_mod(1, Y, Z) :- !, l0b_modm(-1, Y, Z).
l0b_mod(X, Y, Z) :- l0b_modm(X, Y, Z).

l0b_modm(-2, -2, -2). % multi
l0b_modm(-2, -2, 0).
l0b_modm(-2, -1, -2). % multi
l0b_modm(-2, -1, -1).
l0b_modm(-2, -1, 0).
l0b_modm(-2, 1, 2). % multi
l0b_modm(-2, 1, 1).
l0b_modm(-2, 1, 0).
l0b_modm(-2, 2, 2). % multi
l0b_modm(-2, 2, 0).
l0b_modm(-1, -2, -1).
l0b_modm(-1, -1, -2). % multi
l0b_modm(-1, -1, -1).
l0b_modm(-1, -1, 0).
l0b_modm(-1, 1, 2). % multi
l0b_modm(-1, 1, 1).
l0b_modm(-1, 1, 0).
l0b_modm(-1, 2, 1).

% l0b_lt(+X, +Y, -Z) :- X, Y s Z absztrakt egszek, (X < Y) = Z.
l0b_lt(X, Y, Z) :-
  ( X < 0, Y >= 0 -> Z = 1
  ; X = 0, Y > 0 -> Z = 1
  ; X >= 0, Y =< 0 -> Z = 0
  ; ( Z = 0 ; Z = 1 )
  ).

% l0b_le(+X, +Y, -Z) :- X, Y s Z absztrakt egszek, (X <= Y) = Z.
l0b_le(X, Y, Z) :-
  ( X =< 0, Y >= 0 -> Z = 1
  ; X >= 0, Y < 0 -> Z = 0
  ; ( Z = 0 ; Z = 1 )
  ).

% l0a_evalint(+bind, +X, ?E): Az X egsz-kifejezs absztrakt rtke a vltozk Bind
% rtke mellett E. Tbbszrsen is sikerlhet.
l0a_evalint(_Bind,X, E) :- integer(X), !, E is X.
l0a_evalint(Bind, R, E) :- atom(R), !, l0i_get(Bind, R, E).
l0a_evalint(Bind, -X,      E) :- !, l0a_evalint(Bind, X, C), E is -C. % :-)
l0a_evalint(Bind, X +   Y, E) :- !, l0a_evalint(Bind, X, C), l0a_evalint(Bind, Y, D), l0b_add(C, D, E).
l0a_evalint(Bind, X -   Y, E) :- !, l0a_evalint(Bind, X, C), l0a_evalint(Bind, Y, D), D1 is -D, l0b_add(C, D1, E).
l0a_evalint(Bind, X *   Y, E) :- !, l0a_evalint(Bind, X, C), l0a_evalint(Bind, Y, D), l0b_mul(C, D, E).
l0a_evalint(Bind, X div Y, E) :- !, l0a_evalint(Bind, X, C), l0a_evalint(Bind, Y, D), l0b_div(C, D, E).
l0a_evalint(Bind, X mod Y, E) :- !, l0a_evalint(Bind, X, C), l0a_evalint(Bind, Y, D), l0b_mod(C, D, E).
l0a_evalint(Bind, X ==  Y, E) :- !, l0a_evalint(Bind, X, C), l0a_evalint(Bind, Y, D), (E = 0 ; ( C =:= D -> E = 1 )).
l0a_evalint(Bind, X <>  Y, E) :- !, l0a_evalint(Bind, X, C), l0a_evalint(Bind, Y, D), (E = 1 ; ( C =:= D -> E = 0 )).
l0a_evalint(Bind, X <   Y, E) :- !, l0a_evalint(Bind, X, C), l0a_evalint(Bind, Y, D), l0b_lt(C, D, E).
l0a_evalint(Bind, X <=  Y, E) :- !, l0a_evalint(Bind, X, C), l0a_evalint(Bind, Y, D), l0b_le(C, D, E).

% l0a_st0l(Bind, Stam, M, Cind): a vltozk Bind rtke mellett vgrehajtott
% Stam utasts az M cmkre ugrik, s a vltozk rtkt Cind-re mdostja.
% Ha az utasts nem ugrik sehov, hanem halad tovbb, akkor M-et ``step''-pel
% egyestjk.
l0a_st0l(Bind, stop, M, Cind) :- !, M = stop/0, Cind = Bind.
l0a_st0l(Bind, throw _X, M, Cind) :- !,
  % l0a_eval(Bind, X, E)-nek nincs mellkhatsa, ezrt nem hvjuk
  % write('l0 abort: '), write_string(E), nl,
  M = stop/1, Cind = Bind.
l0a_st0l(Bind, input R, M, Cind) :- !,
  M = step,
  ( l0i_let(Bind, R, -2, Cind) % a beolvass rtke brmi lehet
  ; l0i_let(Bind, R, -1, Cind)
  ; l0i_let(Bind, R,  0, Cind)
  ; l0i_let(Bind, R,  1, Cind)
  ; l0i_let(Bind, R,  2, Cind)
  ).
l0a_st0l(Bind, write _X, M, Cind) :- !,
  Cind=Bind, M = step. % absztrakt mdban nem runk ki semmit
l0a_st0l(Bind, let R = X, M, Cind) :- !,
  l0a_eval(Bind, X, E),
  l0i_let(Bind, R, E, Cind), M = step.
l0a_st0l(Bind, if X then goto L, M, Cind) :- !,
  Cind = Bind,
  l0a_eval(Bind, X, E),
  ( E =:= 0 -> M = step
  ; M = L
  ).

%% l0a_set1(As, Bs) :- As s Bs nemres listk. Bs gy ll el, hogy As els
%% elemt 1-re cserljk.
%l0a_set1(As, Bs) :- 
%  As = [A0|Ax],
%  ( A0 = 1 -> Bs = As ; Bs = [1|Ax] ).

% l0a_getr(+Prog, +Reach, +L, -R, -Prog1, -Reach1): R az L cmke
% elrhetsge (0 vagy 1) a Prog programban s Reach elrsi listban; s
% Prog1 a prog L-lel cmkzett rszlistja, s Reach1 a Reach megfelel
% rszlistja.
l0a_getr(Prog, Reach, L, R, Prog1, Reach1) :-
  Reach = [R0|Rs],
  ( Prog = (L -> _ ; Y) -> (R = R0, Prog1 = Prog, Reach1 = Reach)
  ; Prog = (_; Y) -> l0a_getr(Y, Rs, L, R, Prog1, Reach1)
  ).

% l0a_setr(+Prog, +Reach, +L, -Reach1, -Seach): ...
l0a_setr(Prog, Reach, L, Reach1, Seach) :-
  Reach = [R0|Rs],
  ( Prog = (L -> _ ; Y) -> (Seach = [1|Rs], Reach1 = Seach)
  ; Prog = (_; Y) -> (Seach = [R0|Ss], l0a_setr(Y, Rs, L, Reach1, Ss))
  ).

% l0a_goto(+Prog, Reach, +L, -Prog2, -Reach2, -Seach): a Prog programban az
% L cmkre ugorva a Prog2 programrszhez jutunk (Prog2 rszfja Prog-nak),
% s Seach gy ll el, hogy Reach-nek az I-edik elemt 1-re cserljk, ahol
% I db elemet kell elhagyni Prog-bl, hogy Prog2-be jussunk. Reach2 pedig
% Seach-nak a lecserlt 1-essel kezdd rszlistja.
l0a_goto(Prog, Reach, L, Prog2, Reach2, Seach) :-
  l0a_getr(Prog, Reach, L, R, Prog2, Reach1),
  ( R =:= 1 -> (Reach2 = Reach1, Seach = Reach)
  ; l0a_setr(Prog, Reach, L, Reach2, Seach)
  ).

% l0a_program(+Bind, +Prog, +ReachP, +Now, +Reach, -M, -Cind, -Seach):
% a vltozk Bind rtke mellett,
% Now LVG-fa elejtl elkezdve futtatni
% a Prog programot (Now rszfja Prog-nak),
% melyhez a cmkk ReachP elrhetsgi listja tartozik,
% a cmkk Reach elrsi 0--1 listjbl kiindulva;
% a program a vltozk rtkt Cind-re mdostja,
% az M cmknl r vget (M = stop/0 cmke ``stop'' utasts, M = stop/1 
%  ``throw'' utasts hatsrsa keletkezik),
% s Seach lesz a cmkk elrsi listja (stop/_ nem szerepel benne).
%   Az l0a_program absztrakt kirtkelst vgez, ezrt biztosan vges szmtsi
% id utn vget r.
l0a_program(Bind, Prog, ReachP, (K -> Stam ; Y), Reach, M, Cind, Seach) :- !,
  %  trace,
  Reach = [R0|_],
  ( R0 =:= 1 -> (ReachQ = ReachP, Reach2 = Reach)
  ; l0a_setr(Prog, ReachP, K, Reach2, ReachQ) % slow, linear
  ),
  l0a_st0l(Bind, Stam, L, Bond),
  ( L = stop/_ -> (M = K, Cind = Bind, Seach = ReachP)
  ; L = step ->
    Reach2 = [_|Reach3],
    l0a_program(Bond, Prog, ReachQ, Y,     Reach3, M, Cind, Seach)
  ; l0a_getr(Prog, ReachQ, L, _, Prog3, Reach3),
    l0a_program(Bond, Prog, ReachQ, Prog3, Reach3, M, Cind, Seach)
  ).

% l0c_length(+Prog, +Add, ?ProgLen): ProgLen a Prog program utastsainak
% szmnl Add-dal nagyobb
l0c_length((stop/0 -> _ ; _), Add, ProgLen) :- !, ProgLen = Add.
l0c_length((_ -> _Stam ; Y), Add, ProgLen) :-
  Add1 is Add+1,
  l0c_length(Y, Add1, ProgLen).

% l0_fill(+N, +V, ?Ls): Az Ls lista N db v rtk sszeraksval ll el.
l0_fill(0, _, Ls) :- !, Ls = [].
l0_fill(N, V, [V|Lx]) :- N1 is N-1, l0_fill(N1, V, Lx).

% l0c_select(+Prog, +Reach, ?RList) :- a Prog LVG-programban a cmkk Reach
% elrsi 0--1 listja alapjn ellltja az elrt cmkk RList listjt.
l0c_select((stop/0 -> _ ; _), _, RList) :- !, RList = [].
l0c_select((K -> _Stam ; Y), [R0|Rs], RList) :-
  ( R0 = 1 -> RList = [K|RList1]
  ; RList = RList1
  ),
  l0c_select(Y, Rs, RList1).

% l0a_program(+Bind, +Prog, -M, -Cind, -RList):
% a vltozk Bind rtke mellett,
% az elejtl elkezdve futtatni a Prog programot,
% a program a vltozk rtkt Cind-re mdostja,
% az M cmknl r vget (M = stop/0 cmke ``stop'' utasts, M = stop/1 
%  ``throw'' utasts hatsrsa keletkezik),
% s RList lesz az elrt cmkk elrt listja (a programkdban val
%   megjelensk sorrendjben).
l0a_program(Bind, Prog, M, Cind, RList) :-
  l0c_length(Prog, 0, ProgLen),
  ProgLen1 is ProgLen+1,
  l0_fill(ProgLen1, 0, Reach),
  l0a_program(Bind, Prog, Reach, Prog, Reach, M, Cind, Seach), %Seach = Reach,
  l0c_select(Prog, Seach, RList).

% --- ltalnos prba

l0test_abstract(FileName) :-
  print('open:'), nl,
  open(FileName,read,Stream),
  print('read:'), nl,
  read(Stream, X),
  print('parse:'), nl,
  l0x_program(X),
  print('translate:'), nl,
  l0trans_program(X, T),
  print('vars:'), nl,
  l0vars(T, undef, V),
  % l0vars_program(T, [], V),
  print('  '), print(V), nl,
  print('listing:'), nl,
  l0print_program(T),
  print('abstractify:'), nl,
  l0a_abstractprogram(T, TA),
  print('abstract listing:'), nl,
  l0print_program(TA),
  print('abstract evaluation:'), nl,
  l0a_program(V, TA, M, Cind, RList),
  %print('execution:'), nl,
  %l0i_program(V, T, T, M, Cind),
  % vvv innentl tbbszr futhatnak
  print(' exit label: '), print(M), nl,
  print('exit labels: '), print(RList), nl,
  print('exit bindings: '), print(Cind), nl,
  print('done.'), nl,
  fail.

% --- specilis prba

ttt :- % norml md (nem absztrakt)
  %l0test_normal('huszig.l0').
  l0test_normal('tprim.l0').

aaa :- % absztrakt md
  %l0test_abstract('tprim.l0').
  %l0test_abstract('huszig.l0').
  %l0test_abstract('vegtelen.l0').
  l0test_abstract('pozitivak.l0').

% __EOF__

l0test_normal(FileName) :-
  print('open:'), nl,
  open(FileName,read,Stream),
  print('read:'), nl,
  read(Stream, X),
  print('parse:'), nl,
  l0x_program(X),
  print('translate:'), nl,
  l0trans_program(X, T),
  print('vars:'), nl,
  l0vars(T, undef, V),
  % l0vars_program(T, [], V),
  print('  '), print(V), nl,
  print('listing:'), nl,
  l0print_program(T),
  print('execution:'), nl,
  l0i_program(V, T, T, M, Cind),
  print('exit label: '), print(M), nl,
  print('exit bindings: '), print(Cind), nl,
  print('done.'), nl.

